SUBROUTINE Nishio

  USE global_variables
  IMPLICIT NONE

   INTEGER, DIMENSION(9,9) :: sudoku_orig,sudoku_run
   INTEGER, DIMENSION(3,3,3,3) :: smallcell_orig,smallcell_run

   INTEGER, DIMENSION(9,9,9) :: sudoku_logic_orig,sudoku_logic_run
   INTEGER, DIMENSION(9,9) :: sudoku_logic_numbers_orig,sudoku_logic_numbers_run

   INTEGER,DIMENSION(9,9) :: sudoku_logic_nishio

   INTEGER :: check_nishio
   INTEGER :: nishio_array_count,nishio_array_incr
   INTEGER ::  nishio_count_return,nishio_number,nishio_number1
   INTEGER :: i_nishio,j_nishio
   INTEGER :: knumber,lnumber
   INTEGER :: perform_nishio_row1,perform_nishio_col1
   INTEGER :: perform_nishio_row,perform_nishio_col
   INTEGER :: i,j
   INTEGER :: icheck,ipass
   INTEGER :: check_no_moves
   INTEGER :: temp_number
   INTEGER :: i_nishio_start,j_nishio_start
   INTEGER :: cell_other_logic_number,cell_other_numbers
   INTEGER :: inumber
   INTEGER :: check_new_nishio_cell

999  CONTINUE

   sudoku_orig = sudoku
   smallcell_orig = smallcell
   sudoku_logic_orig = sudoku_logic
   sudoku_logic_numbers_orig = sudoku_logic_numbers
   check_nishio = 0
   nishio_count_return = 0

                IF (check_nishio_next .eq. 1) THEN
                   check_nishio_numbers = 0
                   check_nishio_next = 0
                   IF (j_nishio_check .lt. 9) THEN
                      i_nishio_start = i_nishio_check
                      j_nishio_start = j_nishio_check + 1
                   ELSE IF (j_nishio_check .ge. 9) THEN
                      i_nishio_start = i_nishio_check + 1
                      j_nishio_start = 1
                   END IF
                ELSE
                        i_nishio_start = i_nishio_check
                        j_nishio_start = j_nishio_check
                END IF



iloop:    DO i_nishio=i_nishio_start,9
		IF (i_nishio .gt. i_nishio_start) THEN
			j_nishio_start = 1
		END IF
jloop:       DO j_nishio=j_nishio_start,9
                 nishio_count_return = nishio_count_return + 1
                    i_nishio_check = i_nishio
                    j_nishio_check = j_nishio
                 IF (sudoku_logic_numbers_orig(i_nishio,j_nishio) .gt. 0) THEN
                    perform_nishio_row1 = i_nishio
                    perform_nishio_col1 = j_nishio
                    EXIT iloop
                 END IF
             END DO jloop
          END DO iloop


        IF (i_nishio .gt. 9) THEN
                i_nishio_check = 1
                j_nishio_check = 1
                check_nishio_next = 0
                RETURN
        END IF

kloop:    DO knumber=1,sudoku_logic_numbers_orig(perform_nishio_row1,perform_nishio_col1)
                nishio_number1 = sudoku_logic_orig(perform_nishio_row1,perform_nishio_col1,knumber)
                nishio_array_count = 0
                sudoku_run = sudoku_orig
                smallcell_run = smallcell_orig
                sudoku_logic_numbers_run = sudoku_logic_numbers_orig
                sudoku_logic_run = sudoku_logic_orig
                check_nishio = 0
                check_no_moves = 0

  		sudoku_logic_nishio = 0
		DO i=1,9 
		  DO j=1,9
		    IF (sudoku_orig(i,j) .ne. 0) THEN
			IF (sudoku_orig(i,j) .eq. nishio_number1) THEN
				sudoku_logic_nishio(i,j)=2
				CYCLE
			END IF
		    END IF
	 	    cell_other_numbers = sudoku_logic_numbers_orig(i,j)
		    DO inumber=1,cell_other_numbers
			   cell_other_logic_number = sudoku_logic_orig(i,j,inumber)
			   IF (cell_other_logic_number .eq. nishio_number1) THEN
				nishio_array_count = nishio_array_count+1
				sudoku_logic_nishio(i,j) = 1
				EXIT
			   END IF
		    END DO
		  END DO
		END DO

                nishio_number = nishio_number1
                perform_nishio_row = perform_nishio_row1
                perform_nishio_col = perform_nishio_col1

200	CONTINUE

		CALL perform_nishio(sudoku_run,sudoku_logic_nishio, &
				perform_nishio_row,perform_nishio_col,nishio_number)

		CALL check_contradiction(sudoku_run,sudoku_logic_nishio,check_nishio, &
				nishio_number)

                IF (check_nishio .eq. 1) THEN
                   DO lnumber=knumber,sudoku_logic_numbers_orig(perform_nishio_row1,perform_nishio_col1)-1
                       sudoku_logic_orig(perform_nishio_row1,perform_nishio_col1,lnumber) = &
                               sudoku_logic_orig(perform_nishio_row1,perform_nishio_col1,lnumber+1)
                   END DO
                   IF (knumber .eq. sudoku_logic_numbers_orig(perform_nishio_row1,perform_nishio_col1)) THEN
                        check_nishio_next = 1
                   END IF
                   sudoku_logic_numbers_orig(perform_nishio_row1,perform_nishio_col1)  = &
                        sudoku_logic_numbers_orig(perform_nishio_row1,perform_nishio_col1) - 1
                   GO TO 300
                END IF 

		check_new_nishio_cell = 0
		CALL Find_new_nisiho_cell(sudoku_logic_nishio,check_new_nishio_cell, &
				perform_nishio_row,perform_nishio_col)
		IF (check_new_nishio_cell .eq. 1) GO TO 200

	  END DO kloop	

	  check_nishio_next = 1

300  CONTINUE
          IF (check_nishio .eq. 1) THEN
                sudoku_logic_numbers = sudoku_logic_numbers_orig
                sudoku_logic = sudoku_logic_orig

		RETURN
          END IF

	  GO TO 999


END SUBROUTINE Nishio

!----------------------------------------------------------------------------------------------


SUBROUTINE perform_nishio(sudoku_nishio,sudoku_logic_nishio, &
                   perform_nishio_row,perform_nishio_col,nishio_number)

   IMPLICIT NONE

   INTEGER, DIMENSION(9,9) :: sudoku_nishio
   INTEGER, DIMENSION(9,9) :: sudoku_logic_nishio
   INTEGER :: perform_nishio_row,perform_nishio_col
   INTEGER :: nishio_number
  
   INTEGER :: i,j
   INTEGER :: small_cell_row,small_cell_column
   INTEGER :: row_k,column_k
   INTEGER :: ii_other,jj_other

   sudoku_logic_nishio(perform_nishio_row,perform_nishio_col) = 2

   DO j=1,9
     IF ( j .eq. perform_nishio_col) CYCLE
     IF (sudoku_logic_nishio(perform_nishio_row,j) .eq. 1) THEN
	sudoku_logic_nishio(perform_nishio_row,j) = 0
     END IF
   END DO

   DO i=1,9
     IF ( i .eq. perform_nishio_row) CYCLE
     IF (sudoku_logic_nishio(i,perform_nishio_col) .eq. 1) THEN
	sudoku_logic_nishio(i,perform_nishio_col) = 0
     END IF
   END DO

      i = perform_nishio_row
      j = perform_nishio_col

      IF (mod(i,3) .ne. 0) THEN
        small_cell_row = int(i/3)+1
      ELSE
        small_cell_row = int(i/3)
      END IF
      IF (mod(j,3) .ne. 0) THEN
        small_cell_column = int(j/3)+1
      ELSE
        small_cell_column = int(j/3)
      END IF

    IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 1)) THEN
        row_k=1
        column_k=1
    ELSE IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 2)) THEN
        row_k=1
        column_k=4
    ELSE IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 3)) THEN
        row_k=1
        column_k=7
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 1)) THEN
        row_k=4
        column_k=1
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 2)) THEN
        row_k=4
        column_k=4
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 3)) THEN
        row_k=4
        column_k=7
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 1)) THEN
        row_k=7
        column_k=1
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 2)) THEN
        row_k=7
        column_k=4
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 3)) THEN
        row_k=7
        column_k=7
    END IF

    DO ii_other=row_k,row_k+2
       DO jj_other=column_k,column_k+2
          IF ((ii_other .eq. i) .AND. (jj_other .eq. j)) CYCLE
	  IF (sudoku_logic_nishio(ii_other,jj_other) .eq. 1) THEN
		sudoku_logic_nishio(ii_other,jj_other) = 0
	  END IF
       END DO
    END DO


END SUBROUTINE perform_nishio

!--------------------------------------------------------------------------------
 
SUBROUTINE check_contradiction(sudoku_nishio,sudoku_logic_nishio,check_nishio, &
                                nishio_number)

    IMPLICIT NONE

   INTEGER, DIMENSION(9,9) :: sudoku_nishio
   INTEGER, DIMENSION(9,9) :: sudoku_logic_nishio
   INTEGER :: check_nishio
   INTEGER :: nishio_number

  INTEGER :: row_check,col_check,smallcell_check
  INTEGER :: i,j
  INTEGER :: small_cell_row,small_cell_column
  INTEGER :: row_k,column_k,ii_other,jj_other


  DO i=1,9
    row_check = 0
    DO j=1,9
      IF (sudoku_logic_nishio(i,j) .eq. 0) THEN
         row_check = row_check + 1
      END IF
    END DO
    IF(row_check .eq. 9) THEN
         check_nishio = 1
         RETURN
    END IF
  END DO

  DO j=1,9
    col_check = 0
    DO i=1,9
      IF (sudoku_logic_nishio(i,j) .eq. 0) THEN
         col_check = col_check + 1
      END IF
    END DO
    IF(col_check .eq. 9) THEN
         check_nishio = 1
         RETURN
    END IF
  END DO


  DO i=1,9
    DO j=1,9
      smallcell_check = 0

      IF (mod(i,3) .ne. 0) THEN
        small_cell_row = int(i/3)+1
      ELSE
        small_cell_row = int(i/3)
      END IF
      IF (mod(j,3) .ne. 0) THEN
        small_cell_column = int(j/3)+1
      ELSE
        small_cell_column = int(j/3)
      END IF

    IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 1)) THEN
        row_k=1
        column_k=1
    ELSE IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 2)) THEN
        row_k=1
        column_k=4
    ELSE IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 3)) THEN
        row_k=1
        column_k=7
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 1)) THEN
        row_k=4
        column_k=1
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 2)) THEN
        row_k=4
        column_k=4
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 3)) THEN
        row_k=4
        column_k=7
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 1)) THEN
        row_k=7
        column_k=1
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 2)) THEN
        row_k=7
        column_k=4
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 3)) THEN
        row_k=7
        column_k=7
    END IF

   DO ii_other=row_k,row_k+2
     DO jj_other=column_k,column_k+2
        IF (sudoku_logic_nishio(ii_other,jj_other) .eq. 0) THEN
	   smallcell_check = smallcell_check+1
	END IF
     END DO
   END DO
   IF (smallcell_check .eq. 9) THEN
	check_nishio = 1
	RETURN
   END IF

  END DO
 END DO


END SUBROUTINE check_contradiction

!--------------------------------------------------------------------------

SUBROUTINE Find_new_nisiho_cell(sudoku_logic_nishio,check_new_nishio_cell, &
                                perform_nishio_row,perform_nishio_col)

   IMPLICIT NONE

   INTEGER, DIMENSION(9,9) :: sudoku_logic_nishio
   INTEGER :: check_new_nishio_cell
   INTEGER :: perform_nishio_row,perform_nishio_col

  INTEGER :: row_check,col_check,smallcell_check
  INTEGER :: i,j
  INTEGER :: small_cell_row,small_cell_column
  INTEGER :: row_k,column_k,ii_other,jj_other
  INTEGER :: i_row,i_col


  i_row = perform_nishio_row
  i_col = perform_nishio_col

  DO i=1,9
    row_check = 0
    DO j=1,9
     IF (sudoku_logic_nishio(i,j) .eq. 2) CYCLE
      IF (sudoku_logic_nishio(i,j) .eq. 1) THEN
         row_check = row_check + 1
	 i_col = j
      END IF
    END DO
    IF(row_check .eq. 1) THEN
         check_new_nishio_cell = 1
	 perform_nishio_row = i
	 perform_nishio_col = i_col
         RETURN
    END IF
  END DO

  i_row = perform_nishio_row
  i_col = perform_nishio_col

  DO j=1,9
    col_check = 0
    DO i=1,9
     IF (sudoku_logic_nishio(i,j) .eq. 2) CYCLE
      IF (sudoku_logic_nishio(i,j) .eq. 1) THEN
         col_check = col_check + 1
	 i_row = i
      END IF
    END DO
    IF(col_check .eq. 1) THEN
         check_new_nishio_cell = 1
         perform_nishio_row = i_row
         perform_nishio_col = j
         RETURN
    END IF
  END DO

  i_row = perform_nishio_row
  i_col = perform_nishio_col

  DO i=1,9
    DO j=1,9
      smallcell_check = 0

      IF (mod(i,3) .ne. 0) THEN
        small_cell_row = int(i/3)+1
      ELSE
        small_cell_row = int(i/3)
      END IF
      IF (mod(j,3) .ne. 0) THEN
        small_cell_column = int(j/3)+1
      ELSE
        small_cell_column = int(j/3)
      END IF

    IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 1)) THEN
        row_k=1
        column_k=1
    ELSE IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 2)) THEN
        row_k=1
        column_k=4
    ELSE IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 3)) THEN
        row_k=1
        column_k=7
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 1)) THEN
        row_k=4
        column_k=1
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 2)) THEN
        row_k=4
        column_k=4
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 3)) THEN
        row_k=4
        column_k=7
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 1)) THEN
        row_k=7
        column_k=1
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 2)) THEN
        row_k=7
        column_k=4
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 3)) THEN
        row_k=7
        column_k=7
    END IF

   DO ii_other=row_k,row_k+2
     DO jj_other=column_k,column_k+2
        IF (sudoku_logic_nishio(ii_other,jj_other) .eq. 2) CYCLE
        IF (sudoku_logic_nishio(ii_other,jj_other) .eq. 1) THEN
           smallcell_check = smallcell_check+1
	   i_row = ii_other
	   i_col = jj_other
        END IF
     END DO
   END DO
   IF (smallcell_check .eq. 1) THEN
        check_new_nishio_cell = 1
	perform_nishio_row = i_row
	perform_nishio_col = i_col
        RETURN
   END IF

  END DO 
 END DO


END SUBROUTINE Find_new_nisiho_cell

!---------------------------------------------------------------------
