SUBROUTINE Bowman_bingo

   USE global_variables
   IMPLICIT NONE

   INTEGER, DIMENSION(9,9) :: sudoku_orig,sudoku_run
   INTEGER, DIMENSION(3,3,3,3) :: smallcell_orig,smallcell_run

   INTEGER, DIMENSION(9,9,9) :: sudoku_logic_orig,sudoku_logic_run
   INTEGER, DIMENSION(9,9) :: sudoku_logic_numbers_orig,sudoku_logic_numbers_run
   INTEGER,DIMENSION(81,2) :: bowman_array

   INTEGER :: check_bowman_bingo 
   INTEGER :: bowman_array_count,bowman_array_incr
   INTEGER ::  bowman_count_return,bowman_number,bowman_number1
   INTEGER :: i_bowman,j_bowman
   INTEGER :: knumber,lnumber
   INTEGER :: perform_bowman_row,perform_bowman_col
   INTEGER :: perform_bowman_row1,perform_bowman_col1
   INTEGER :: i,j
   INTEGER :: icheck,ipass
   INTEGER :: check_no_moves
   INTEGER :: temp_number
   INTEGER :: i_bowman_start,j_bowman_start

1999  CONTINUE

   sudoku_orig = sudoku
   smallcell_orig = smallcell
   sudoku_logic_orig = sudoku_logic
   sudoku_logic_numbers_orig = sudoku_logic_numbers
   check_bowman_bingo = 0
   bowman_count_return = 0

		IF (check_bowman_next .eq. 1) THEN
		   check_bowman_numbers = 0
		   check_bowman_next = 0
		   IF (j_bowman_check .lt. 9) THEN
		      i_bowman_start = i_bowman_check
		      j_bowman_start = j_bowman_check + 1
		   ELSE IF (j_bowman_check .ge. 9) THEN
		      i_bowman_start = i_bowman_check + 1
		      j_bowman_start = 1
		   END IF
		ELSE
			i_bowman_start = i_bowman_check
			j_bowman_start = j_bowman_check
		END IF
iloop:    DO i_bowman=i_bowman_start,9
                IF (i_bowman .gt. i_bowman_start) THEN
                        j_bowman_start = 1
                END IF
jloop:	     DO j_bowman=j_bowman_start,9
		 bowman_count_return = bowman_count_return + 1
		    i_bowman_check = i_bowman
		    j_bowman_check = j_bowman
	         IF (sudoku_logic_numbers_orig(i_bowman,j_bowman) .gt. 0) THEN
		    perform_bowman_row1 = i_bowman
		    perform_bowman_col1 = j_bowman
		    EXIT iloop
		 END IF
100	 CONTINUE
	     END DO jloop
          END DO iloop

	IF (i_bowman .gt. 9) THEN
		i_bowman_check = 1
		j_bowman_check = 1
		check_bowman_next = 0
		RETURN
	END IF

kloop:	  DO knumber=1,sudoku_logic_numbers_orig(perform_bowman_row1,perform_bowman_col1) 
		bowman_number1 = sudoku_logic_orig(perform_bowman_row1,perform_bowman_col1,knumber)
		bowman_array_count = 0
		bowman_array = 0
		bowman_array_incr = 0
		sudoku_run = sudoku_orig
		smallcell_run = smallcell_orig
		sudoku_logic_numbers_run = sudoku_logic_numbers_orig
		sudoku_logic_run = sudoku_logic_orig
   		check_bowman_bingo = 0
		check_no_moves = 0

		bowman_number = bowman_number1
		perform_bowman_row = perform_bowman_row1
		perform_bowman_col = perform_bowman_col1
200	CONTINUE	
		sudoku_run(perform_bowman_row,perform_bowman_col) = bowman_number

		sudoku_logic_numbers_run(perform_bowman_row,perform_bowman_col) = 1
		sudoku_logic_run(perform_bowman_row,perform_bowman_col,1) = bowman_number
		
                DO icheck=1,bowman_array_count
                END DO

		CALL Forced_moves_Bowman_bingo(perform_bowman_row,perform_bowman_col, &
				sudoku_run,smallcell_run,sudoku_logic_numbers_run, &
				sudoku_logic_run,bowman_array_count,bowman_array)

		CALL Pinned_moves_Bowman_bingo(perform_bowman_row,perform_bowman_col, &
				sudoku_run,smallcell_run,sudoku_logic_numbers_run, &
				sudoku_logic_run,bowman_array_count,bowman_array)

 		!We man not need to call Force_moves_Bowman_bingo again.. CHECK THIS !!!
		CALL Forced_moves_Bowman_bingo(perform_bowman_row,perform_bowman_col, &
				sudoku_run,smallcell_run,sudoku_logic_numbers_run, &
				sudoku_logic_run,bowman_array_count,bowman_array)

                IF (bowman_array_count .eq. 0) THEN
		   temp_number = sudoku_logic_orig(perform_bowman_row1,perform_bowman_col1,knumber)
                   DO lnumber=knumber,sudoku_logic_numbers_orig(perform_bowman_row1,perform_bowman_col1)-1
                       sudoku_logic_orig(perform_bowman_row1,perform_bowman_col1,lnumber) = &
                               sudoku_logic_orig(perform_bowman_row1,perform_bowman_col1,lnumber+1)
                   END DO
		   sudoku_logic_orig(perform_bowman_row1,perform_bowman_col1,lnumber) = temp_number
		   check_no_moves = 1
		   IF (knumber .eq. sudoku_logic_numbers_orig(perform_bowman_row1,perform_bowman_col1)) THEN
			check_bowman_next = 1
		   END IF
		   check_bowman_numbers = check_bowman_numbers + 1
	IF (check_bowman_numbers .gt. sudoku_logic_numbers_orig(perform_bowman_row1,perform_bowman_col1)) THEN
		   check_bowman_next = 1
	END IF
		   GO TO 300
		END IF

		CALL check_contradiction_Bowman_bingo(sudoku_run,check_bowman_bingo)

		IF (check_bowman_bingo .eq. 1) THEN
               	   DO lnumber=knumber,sudoku_logic_numbers_orig(perform_bowman_row1,perform_bowman_col1)-1
                       sudoku_logic_orig(perform_bowman_row1,perform_bowman_col1,lnumber) = &
                               sudoku_logic_orig(perform_bowman_row1,perform_bowman_col1,lnumber+1)
                   END DO
                   IF (knumber .eq. sudoku_logic_numbers_orig(perform_bowman_row1,perform_bowman_col1)) THEN
                        check_bowman_next = 1
                   END IF
                   sudoku_logic_numbers_orig(perform_bowman_row1,perform_bowman_col1)  = &
                        sudoku_logic_numbers_orig(perform_bowman_row1,perform_bowman_col1) - 1
		   GO TO 300
		END IF	
		
		IF (check_bowman_bingo .eq. 0) THEN
		     bowman_array_incr = bowman_array_incr + 1
		     IF (bowman_array_incr .le. bowman_array_count) THEN
			perform_bowman_row = bowman_array(bowman_array_incr,1)
			perform_bowman_col = bowman_array(bowman_array_incr,2)
			bowman_number = sudoku_run(perform_bowman_row,perform_bowman_col)
			GO TO 200
		     END IF
		END IF
	
	  END DO kloop

	  check_bowman_next = 1

300  CONTINUE
	  IF (check_no_moves .eq. 1) THEN
		sudoku_logic_numbers = sudoku_logic_numbers_orig
		sudoku_logic = sudoku_logic_orig
	  END IF

	  IF (check_bowman_bingo .eq. 1) THEN
		sudoku_logic_numbers = sudoku_logic_numbers_orig
		sudoku_logic = sudoku_logic_orig

		RETURN
	  END IF

	  GO TO 1999


END SUBROUTINE Bowman_bingo

!--------------------------------------------------------------------------------------------

SUBROUTINE Forced_moves_Bowman_bingo(perform_bowman_row,perform_bowman_col, &
				sudoku,smallcell,sudoku_logic_numbers, &
                                sudoku_logic,bowman_array_count,bowman_array)

  IMPLICIT NONE

   INTEGER, DIMENSION(9,9) :: sudoku
   INTEGER, DIMENSION(3,3,3,3) :: smallcell
   INTEGER, DIMENSION(9,9,9) :: sudoku_logic
   INTEGER, DIMENSION(9,9) :: sudoku_logic_numbers
   INTEGER,DIMENSION(81,2) :: bowman_array
   INTEGER :: bowman_array_count
   INTEGER :: perform_bowman_row,perform_bowman_col

  INTEGER :: i,j
  INTEGER :: small_cell_row,small_cell_column
  INTEGER :: ith,jth
  INTEGER :: row_k,column_k
  INTEGER :: i_row,j_column,temp_number
  INTEGER,DIMENSION(9) :: temp_array
  INTEGER :: check_number,cell_other_numbers,cell_other_logic_number
  INTEGER :: inumber,ii_other,jj_other
  INTEGER :: ii,jj

   DO ii=1,1
    i = perform_bowman_row
    DO jj=1,1
	j=perform_bowman_col
        IF ((sudoku_logic_numbers(i,j) == 1)) THEN
                sudoku(i,j) = sudoku_logic(i,j,1)
                sudoku_logic_numbers(i,j) = 0
                sudoku_logic(i,j,1) = 0
                check_number = sudoku(i,j)

      IF (mod(i,3) .ne. 0) THEN
        small_cell_row = int(i/3)+1
      ELSE
        small_cell_row = int(i/3)
      END IF
      IF (mod(j,3) .ne. 0) THEN
        small_cell_column = int(j/3)+1
      ELSE
        small_cell_column = int(j/3)
      END IF

    IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 1)) THEN
        row_k=1
        column_k=1
    ELSE IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 2)) THEN
        row_k=1
        column_k=4
    ELSE IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 3)) THEN
        row_k=1
        column_k=7
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 1)) THEN
        row_k=4
        column_k=1
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 2)) THEN
        row_k=4
        column_k=4
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 3)) THEN
        row_k=4
        column_k=7
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 1)) THEN
        row_k=7
        column_k=1
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 2)) THEN
        row_k=7
        column_k=4
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 3)) THEN
        row_k=7
        column_k=7
    END IF


                DO i_row=1,9
                  temp_number=0
                  temp_array=0
                  IF (sudoku(i_row,j) .ne. 0) CYCLE
                  IF (i_row .eq. i) CYCLE
                  cell_other_numbers = sudoku_logic_numbers(i_row,j)
                  DO inumber=1,cell_other_numbers
                    cell_other_logic_number=sudoku_logic(i_row,j,inumber)
                    IF ((cell_other_logic_number .ne. check_number)) THEN
                        temp_number=temp_number+1
                        temp_array(temp_number) = cell_other_logic_number
                    END IF
                  END DO
                  DO inumber=1,sudoku_logic_numbers(i_row,j)
                    sudoku_logic(i_row,j,inumber) = 0
                  END DO
                  sudoku_logic_numbers(i_row,j) = temp_number
                  DO inumber=1,temp_number
                    sudoku_logic(i_row,j,inumber) = temp_array(inumber)
                  END DO
		  IF (temp_number .eq. 1) THEN
			sudoku(i_row,j) = sudoku_logic(i_row,j,1)
                        bowman_array_count = bowman_array_count + 1
                        bowman_array(bowman_array_count,1) = i_row
                        bowman_array(bowman_array_count,2) = j
		  END IF
                END DO

                DO j_column=1,9
                  temp_number=0
                  temp_array=0
                  IF (sudoku(i,j_column) .ne. 0) CYCLE
                  IF (j_column .eq. j) CYCLE
                  cell_other_numbers = sudoku_logic_numbers(i,j_column)
                  DO inumber=1,cell_other_numbers
                    cell_other_logic_number=sudoku_logic(i,j_column,inumber)
                    IF ((cell_other_logic_number .ne. check_number)) THEN
                        temp_number=temp_number+1
                        temp_array(temp_number) = cell_other_logic_number
                    END IF
                  END DO
                  DO inumber=1,sudoku_logic_numbers(i,j_column)
                    sudoku_logic(i,j_column,inumber) = 0
                  END DO
                  sudoku_logic_numbers(i,j_column) = temp_number
                  DO inumber=1,temp_number
                    sudoku_logic(i,j_column,inumber) = temp_array(inumber)
                  END DO
		  IF (temp_number .eq. 1) THEN
			sudoku(i,j_column) = sudoku_logic(i,j_column,1)
                 	bowman_array_count = bowman_array_count + 1
                 	bowman_array(bowman_array_count,1) = i
                 	bowman_array(bowman_array_count,2) = j_column
		  END IF
                END DO


                DO ii_other=row_k,row_k+2
                  DO jj_other=column_k,column_k+2
                    temp_number=0
                    temp_array=0
                    IF (sudoku(ii_other,jj_other) .ne. 0) CYCLE
                    IF ((ii_other .eq. i) .AND. (jj_other .eq. j)) CYCLE
                    cell_other_numbers=sudoku_logic_numbers(ii_other,jj_other)
                    DO inumber=1,cell_other_numbers
                      cell_other_logic_number=sudoku_logic(ii_other,jj_other,inumber)
                      IF (cell_other_logic_number .ne. check_number) THEN
                        temp_number=temp_number+1
                        temp_array(temp_number) = cell_other_logic_number
                      END IF
                    END DO
                      DO inumber=1,sudoku_logic_numbers(ii_other,jj_other)
                        sudoku_logic(ii_other,jj_other,inumber) = 0
                      END DO
                      sudoku_logic_numbers(ii_other,jj_other) = temp_number
                      DO inumber=1,temp_number
                        sudoku_logic(ii_other,jj_other,inumber) = temp_array(inumber)
                      END DO
		  IF (temp_number .eq. 1) THEN
			sudoku(ii_other,jj_other) = sudoku_logic(ii_other,jj_other,1)
                        bowman_array_count = bowman_array_count + 1
                        bowman_array(bowman_array_count,1) = ii_other
                        bowman_array(bowman_array_count,2) = jj_other
		  END IF
                  END DO
		END DO

        END IF
    END DO
  END DO

END SUBROUTINE Forced_moves_Bowman_bingo
!--------------------------------------------------------------------------

SUBROUTINE Pinned_moves_Bowman_bingo(perform_bowman_row,perform_bowman_col, &
				sudoku,smallcell,sudoku_logic_numbers, &
                                sudoku_logic,bowman_array_count,bowman_array)

  IMPLICIT NONE

   INTEGER, DIMENSION(9,9) :: sudoku
   INTEGER, DIMENSION(3,3,3,3) :: smallcell
   INTEGER, DIMENSION(9,9,9) :: sudoku_logic
   INTEGER, DIMENSION(9,9) :: sudoku_logic_numbers
   INTEGER,DIMENSION(81,2) :: bowman_array
   INTEGER :: bowman_array_count
   INTEGER :: perform_bowman_row,perform_bowman_col

  INTEGER ::i,j,k
  INTEGER,DIMENSION(9) :: pinned_squares
  INTEGER :: cell_other_numbers,inumber,cell_other_logic_number
  INTEGER :: cell_other_numbers_1,inumber_1
  INTEGER :: small_cell_row,small_cell_column,row_k,column_k
  INTEGER,DIMENSION(9) :: temp_array
  INTEGER :: temp_number,cell_other_numbers_2,knumber,cell_other_logic_number_2
  INTEGER :: ii_other,jj_other,cell_other_numbers_3,cell_other_logic_number_3
  INTEGER :: ii,jj,kk
  INTEGER :: ii_other1,jj_other1

  DO ii=1,1
    i = perform_bowman_row
    pinned_squares = 0
    DO j=1,9
      cell_other_numbers = sudoku_logic_numbers(i,j)
	IF (cell_other_numbers .eq. 0) CYCLE
      DO inumber=1,cell_other_numbers
        cell_other_logic_number = sudoku_logic(i,j,inumber)
        pinned_squares(cell_other_logic_number)=pinned_squares(cell_other_logic_number)+1
      END DO
    END DO
inumber_loop:    DO inumber=1,9
      IF (pinned_squares(inumber) .eq. 1) THEN
        DO j=1,9
          IF (sudoku(i,j) .ne. 0) CYCLE
          cell_other_numbers_1 = sudoku_logic_numbers(i,j)
          DO inumber_1=1,cell_other_numbers_1
            cell_other_logic_number=sudoku_logic(i,j,inumber_1)
             IF (cell_other_logic_number .eq. inumber) THEN
                sudoku(i,j) = inumber
		bowman_array_count = bowman_array_count + 1
		 bowman_array(bowman_array_count,1) = i
		 bowman_array(bowman_array_count,2) = j
      IF (mod(i,3) .ne. 0) THEN
        small_cell_row = int(i/3)+1
      ELSE
        small_cell_row = int(i/3)
      END IF
      IF (mod(j,3) .ne. 0) THEN
        small_cell_column = int(j/3)+1
      ELSE
        small_cell_column = int(j/3)
      END IF

    IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 1)) THEN
        row_k=1
        column_k=1
    ELSE IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 2)) THEN
        row_k=1
        column_k=4
    ELSE IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 3)) THEN
        row_k=1
        column_k=7
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 1)) THEN
        row_k=4
        column_k=1
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 2)) THEN
        row_k=4
        column_k=4
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 3)) THEN
        row_k=4
        column_k=7
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 1)) THEN
        row_k=7
        column_k=1
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 2)) THEN
        row_k=7
        column_k=4
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 3)) THEN
        row_k=7
        column_k=7
    END IF

                CYCLE inumber_loop
             END IF
          END DO
        END DO
      END IF
     END DO inumber_loop
  END DO

   DO jj=1,1
    j = perform_bowman_col
    pinned_squares = 0
    DO i=1,9
      cell_other_numbers = sudoku_logic_numbers(i,j)
	IF (cell_other_numbers .eq. 0) CYCLE
      DO inumber=1,cell_other_numbers
        cell_other_logic_number = sudoku_logic(i,j,inumber)
        pinned_squares(cell_other_logic_number)=pinned_squares(cell_other_logic_number)+1
      END DO
    END DO
jnumber_loop:    DO inumber=1,9
      IF (pinned_squares(inumber) .eq. 1) THEN
        DO i=1,9
          IF (sudoku(i,j) .ne. 0) CYCLE
          cell_other_numbers_1 = sudoku_logic_numbers(i,j)
          DO inumber_1=1,cell_other_numbers_1
            cell_other_logic_number=sudoku_logic(i,j,inumber_1)
             IF (cell_other_logic_number .eq. inumber) THEN
                sudoku(i,j) = inumber
                bowman_array_count = bowman_array_count + 1
                 bowman_array(bowman_array_count,1) = i
                 bowman_array(bowman_array_count,2) = j
      IF (mod(i,3) .ne. 0) THEN
        small_cell_row = int(i/3)+1
      ELSE
        small_cell_row = int(i/3)
      END IF
      IF (mod(j,3) .ne. 0) THEN
        small_cell_column = int(j/3)+1
      ELSE
        small_cell_column = int(j/3)
      END IF

    IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 1)) THEN
        row_k=1
        column_k=1
    ELSE IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 2)) THEN
        row_k=1
        column_k=4
    ELSE IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 3)) THEN
        row_k=1
        column_k=7
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 1)) THEN
        row_k=4
        column_k=1
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 2)) THEN
        row_k=4
        column_k=4
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 3)) THEN
        row_k=4
        column_k=7
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 1)) THEN
        row_k=7
        column_k=1
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 2)) THEN
        row_k=7
        column_k=4
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 3)) THEN
        row_k=7
        column_k=7
    END IF

                CYCLE jnumber_loop
             END IF
          END DO
        END DO
      END IF
     END DO jnumber_loop
  END DO

  i = perform_bowman_row
  j = perform_bowman_col

      IF (mod(i,3) .ne. 0) THEN
        small_cell_row = int(i/3)+1
      ELSE
        small_cell_row = int(i/3)
      END IF
      IF (mod(j,3) .ne. 0) THEN
        small_cell_column = int(j/3)+1
      ELSE
        small_cell_column = int(j/3)
      END IF

    IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 1)) THEN
        row_k=1
        column_k=1
    ELSE IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 2)) THEN
        row_k=1
        column_k=4
    ELSE IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 3)) THEN
        row_k=1
        column_k=7
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 1)) THEN
        row_k=4
        column_k=1
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 2)) THEN
        row_k=4
        column_k=4
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 3)) THEN
        row_k=4
        column_k=7
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 1)) THEN
        row_k=7
        column_k=1
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 2)) THEN
        row_k=7
        column_k=4
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 3)) THEN
        row_k=7
        column_k=7
    END IF

!GO TO 999

  DO ii_other1=row_k,row_k+2
     DO jj_other1=column_k,column_k+2

        cell_other_numbers = sudoku_logic_numbers(ii_other1,jj_other1)
        DO inumber=1,cell_other_numbers
          cell_other_logic_number=sudoku_logic(ii_other1,jj_other1,inumber)
          pinned_squares(cell_other_logic_number)=pinned_squares(cell_other_logic_number)+1
        END DO
      END DO
     END DO


iinumber_loop: DO inumber=1,9
   IF (pinned_squares(inumber) .eq. 1) THEN
     DO ii_other=row_k,row_k+2
       DO jj_other=column_k,column_k+2
	 IF (sudoku(ii_other,jj_other) .ne. 0) CYCLE
         cell_other_numbers=sudoku_logic_numbers(ii_other,jj_other)
         DO inumber_1=1,cell_other_numbers
            cell_other_logic_number=sudoku_logic(ii_other,jj_other,inumber_1)
	    IF (cell_other_logic_number .eq. inumber) THEN
	        sudoku(ii_other,jj_other) = inumber
                 bowman_array_count = bowman_array_count + 1
                 bowman_array(bowman_array_count,1) = ii_other
                 bowman_array(bowman_array_count,2) = jj_other

                CYCLE iinumber_loop
             END IF
          END DO
        END DO
       END DO	
      END IF
     END DO iinumber_loop

!999 CONTINUE

END SUBROUTINE Pinned_moves_Bowman_bingo
!--------------------------------------------------------------------------

SUBROUTINE check_contradiction_Bowman_bingo(sudoku,check_bowman_bingo)

  IMPLICIT NONE 

  INTEGER, DIMENSION(9,9) :: sudoku 
  INTEGER :: check_bowman_bingo

  INTEGER,DIMENSION(9) :: row_check,col_check,smallcell_check
  INTEGER :: i,j,inumber
  INTEGER :: small_cell_row,small_cell_column
  INTEGER :: row_k,column_k,ii_other,jj_other

  DO i=1,9
    row_check = 0
    DO j=1,9
      IF (sudoku(i,j) .eq. 0) CYCLE
      row_check(sudoku(i,j)) = row_check(sudoku(i,j)) + 1
    END DO
    DO inumber=1,9
      IF(row_check(inumber) .gt. 1) THEN
	 check_bowman_bingo = 1
	 RETURN
      END IF
    END DO
  END DO
 
  DO j=1,9
    col_check = 0
    DO i=1,9
      IF (sudoku(i,j) .eq. 0) CYCLE
      col_check(sudoku(i,j)) = col_check(sudoku(i,j)) + 1
    END DO
    DO inumber=1,9
      IF(col_check(inumber) .gt. 1) THEN
         check_bowman_bingo = 1
         RETURN
      END IF
    END DO
  END DO

  DO i=1,9
    DO j=1,9
      smallcell_check = 0

      IF (mod(i,3) .ne. 0) THEN
        small_cell_row = int(i/3)+1
      ELSE
        small_cell_row = int(i/3)
      END IF
      IF (mod(j,3) .ne. 0) THEN
        small_cell_column = int(j/3)+1
      ELSE
        small_cell_column = int(j/3)
      END IF

    IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 1)) THEN
        row_k=1
        column_k=1
    ELSE IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 2)) THEN
        row_k=1
        column_k=4
    ELSE IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 3)) THEN
        row_k=1
        column_k=7
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 1)) THEN
        row_k=4
        column_k=1
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 2)) THEN
        row_k=4
        column_k=4
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 3)) THEN
        row_k=4
        column_k=7
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 1)) THEN
        row_k=7
        column_k=1
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 2)) THEN
        row_k=7
        column_k=4
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 3)) THEN
        row_k=7
        column_k=7
    END IF

   DO ii_other=row_k,row_k+2
     DO jj_other=column_k,column_k+2
        IF (sudoku(ii_other,jj_other) .ne. 0) THEN
          smallcell_check(sudoku(ii_other,jj_other)) = smallcell_check(sudoku(ii_other,jj_other))+1
        END IF
      END DO
     END DO

    DO inumber=1,9
      IF(smallcell_check(inumber) .gt. 1) THEN
         check_bowman_bingo = 1
         RETURN
      END IF
    END DO

  END DO
 END DO


END SUBROUTINE check_contradiction_Bowman_bingo

!-----------------------------------------------------------------------------------
 
